unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.ExtCtrls,
  Vcl.Grids, Math;

type
  TForm1 = class(TForm)
    OpenBtn: TButton;
    SigumaGrid: TStringGrid;
    REdit: TLabeledEdit;
    SEdit: TLabeledEdit;
    FilterBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    Label1: TLabel;
    KEdit: TLabeledEdit;
    Label2: TLabel;
    ReDrawBtn: TButton;
    crossBtn: TButton;
    OffEdit: TLabeledEdit;
    CheckBox1: TCheckBox;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    procedure FilterBtnClick(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ReDrawBtnClick(Sender: TObject);
    procedure crossBtnClick(Sender: TObject);
    procedure SEditChange(Sender: TObject);
  private
    { Private 錾 }
    procedure LogMask;
    procedure Masking;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
const
  FileOpenFilter = 'Image File|*.jpg;*.jpeg;*.tif;*.tiff;*.png;*.gif;*.bmp;*.wdp' +
                   '|*.Jpg|*.jpg' +
                   '|*.Tif|*.tif' +
                   '|*.Png|*.png' +
                   '|*.Gif|*.gif' +
                   '|*.Bmp|*.bmp' +
                   '|*.Wdp|*.wdp';

  RK    = 0.298912;                           // O[XP[PxW@
  GK    = 0.586611;                           // O[XP[PxW@
  BK    = 0.114478;                           // O[XP[PxW@

var
  SXY : array of array of double;   // tB^[z
  MatSize : integer;                // tB^[TCY
  MDIV2   : integer;
  Total   : double;

  Inputbitmap       : Tbitmap;                    // t@C͗prbg}bv
  OutPutbitmap      : Tbitmap;                    // t@C͗prbg}bv

  GrayMat           : array of array of double;
  MaskedMat         : array of array of Byte;
  FMaskedMat        : array of array of double;

  GHeight, GWidth : Integer;                      // ͉摜TCY
  RepF            : Boolean;
  K             : double;

//-------------------------------
// LoGtB^[̎s[`
//-------------------------------
procedure TForm1.Masking;
var
  X, Y, WX, WY    : integer;
  Xm, Ym, Xd, Yd  : integer;
  Mx, My          : integer;
  Siguma          : double;
  Isiguma         : integer;
  PD              : PByteArray;
  WD              : integer;
begin
  setlength(MaskedMat, GWidth, GHeight);
  setlength(FMaskedMat, GWidth, GHeight);
  OutPutbitmap.SetSize(GWidth, GHeight);
  WX := GWidth  - 1;
  WY := GHeight - 1;
  // LoG tB^[̎{
  for X := 0 to WX do
    for Y := 0 to WY do begin
      siguma := 0;
      for Xm := - MDIV2 to MDIV2 do begin
        Mx := Xm + MDIV2;
        Xd := X + Xm;
        if Xd < 0 then Xd := -Xd;
        if Xd > WX then Xd := WX + WX - Xd;     // Xd := WX - (Xd - WX);
        for Ym := - MDIV2 to MDIV2 do begin
          My := Ym + MDIV2;
          Yd := Y + Ym;
          if Yd < 0 then Yd := -Yd;
          if Yd > WY then Yd := WY + WY - Yd;   // Yd := WY - (Yd - WY);
          siguma := siguma + GrayMat[Xd, Yd] * SXY[Mx, My];
        end;
      end;
      // _l
      FMaskedMat[X, Y] := siguma;               // _p_̂܁Tgp܂
      // 
      Isiguma := round(siguma + 127);           // [_̒l𒆊ԓ_127ɐݒ
      if Isiguma < 0 then Isiguma := 0;
      if Isiguma > 255 then Isiguma := 255;
      // Bytef[^[
      MaskedMat[X, Y] := Isiguma;
    end;
  // O[XP[摜̐
  for Y := 0 to WY do begin
    PD := OutPutbitmap.ScanLine[Y];
    for X := 0 to WX do begin
      WD := X * 3;
      PD[WD    ] := MaskedMat[X, Y];
      PD[WD + 1] := MaskedMat[X, Y];
      PD[WD + 2] := MaskedMat[X, Y];
    end;
  end;
  Image1.Canvas.Draw(0, 0, Outputbitmap);          // o͘gɏo
end;

//----------------------------------------------------------------
// _̌o
// ԓ_ X     3x3 }gbNX    2x2 }gbNX
//               a b c               ab
//               d X f               cd
//               g h i
//  3x3  d>X>f  d<X<f b>X>h  b<X<h  a>X>i  a<X<i  c>X>g  c<X<g
//  2x3  a>X>b  a<X<b a>X>c  a<X<c  a>X>d  a<X<d  b>X>c  b<X<c
//----------------------------------------------------------------
procedure TForm1.crossBtnClick(Sender: TObject);
var
  X, Y      : integer;
  ThP, Thm  : double;                                 //@+- Threshold
  PD        : PByteArray;
  WD        : integer;
  Offset    : double;                                 // Thresholdp͒l

  function crosscheck(a, b: double): boolean;
  begin
    result := false;
    if (a > ThP) and (b < Thm) then result := true;
    if (a < Thm) and (b > ThP) then result := true;
  end;

begin
  val(OffEdit.Text, Offset, WD);
  if WD <> 0 then begin
    application.MessageBox('Threshold ͂ɊԈႢ܂B', 'Threshold', 0);
    exit;
  end;
  // l̏㉺ݒ
  ThP := (Total * K + Offset);
  ThM := (Total * K - Offset);
  if CheckBox1.Checked = True then begin  // 2x2 _o
    // _
    for X := 1 to GWidth - 1 do
      for Y := 1 to GHeight - 1 do begin
        MaskedMat[X, Y] := 0;
        if crosscheck(FMaskedMat[X-1, Y-1], FMaskedMat[X  , Y-1]) then MaskedMat[X, Y] := 255;  // E
        if crosscheck(FMaskedMat[X-1, Y-1], FMaskedMat[X-1, Y  ]) then MaskedMat[X, Y] := 255;  // ㉺
        if crosscheck(FMaskedMat[X-1, Y-1], FMaskedMat[X  , Y  ]) then MaskedMat[X, Y] := 255;  // E
        if crosscheck(FMaskedMat[X  , Y-1], FMaskedMat[X-1, Y  ]) then MaskedMat[X, Y] := 255;  // E㍶
      end;
  end
  else begin                              // 3x3 _o
    // _
    for X := 1 to GWidth - 2 do
      for Y := 1 to GHeight - 2 do begin
        MaskedMat[X, Y] := 0;
        if crosscheck(FMaskedMat[X-1, Y  ], FMaskedMat[X+1, Y  ]) then MaskedMat[X, Y] := 255;  // E
        if crosscheck(FMaskedMat[X  , Y-1], FMaskedMat[X  , Y+1]) then MaskedMat[X, Y] := 255;  // ㉺
        if crosscheck(FMaskedMat[X-1, Y-1], FMaskedMat[X+1, Y+1]) then MaskedMat[X, Y] := 255;  // E
        if crosscheck(FMaskedMat[X+1, Y-1], FMaskedMat[X-1, Y+1]) then MaskedMat[X, Y] := 255;  // E㍶
      end;
  end;
  // mNQl摜
  for Y := 0 to GHeight - 1 do begin
    PD := OutPutbitmap.ScanLine[Y];
    for X := 0 to Gwidth - 1 do begin
      WD := X * 3;
      PD[WD    ] := MaskedMat[X, Y];
      PD[WD + 1] := MaskedMat[X, Y];
      PD[WD + 2] := MaskedMat[X, Y];
    end;
  end;
  Image1.Canvas.Draw(0, 0 , Outputbitmap);          // o͘gɏo
end;

//---------------------
// LogtB^[̎{
//---------------------
procedure TForm1.FilterBtnClick(Sender: TObject);
begin
  LogMask;                    // LoGtB^[
  Masking;                    // LoGtB^[̎{
  ReDrawBtn.Enabled := True;
  RepF := True;
  crossbtn.Enabled := True;
end;

//------------------------
// LoGtB^[̍쐬
//------------------------
procedure TForm1.LogMask;
var
  sigma, LogXY  : double;
  RS            : integer;
  Ch            : integer;
  X, Y          : integer;
begin
  val(REdit.Text, RS, Ch);
  if Ch <> 0 then begin
    application.MessageBox('R ɊԈႢ܂B', 'aR', 0);
    exit;
  end;
  val(SEdit.Text, sigma, Ch);
  if Ch <> 0 then begin
    application.MessageBox(' ɊԈႢ܂B', 'VO} ', 0);
    exit;
  end;
  val(KEdit.Text, K, Ch);
  if Ch <> 0 then begin
    application.MessageBox('QC G ɊԈႢ܂B', 'QC G', 0);
    exit;
  end;
  //tB^[z̊m
  MatSize := RS * 2 + 1;
  SetLength(SXY, MatSize, MatSize);
  // XgOObh̐ݒ
  SigumaGrid.ColCount := MatSize div 2 + 2;
  SigumaGrid.RowCount := MatSize div 2 + 2;
  SigumaGrid.ClientWidth  := (SigumaGrid.DefaultColWidth  + 1) * (MatSize div 2 + 2);
  SigumaGrid.ClientHeight := (SigumaGrid.DefaultRowHeight + 1) * (MatSize div 2 + 2);
  // ŒZɃio[O
  MDIV2 := MatSize div 2;
  for Y := MDIV2 downto 0 do SigumaGrid.Cells[0 , MDIV2 - Y + 1] := intTostr(Y);
  for X := MDIV2 downto 0 do SigumaGrid.Cells[X + 1,  0] := intTostr(X);
  // tB^[lvZƕ\
  Total := 0;
  for Y := - MDIV2 to MDIV2 do
    for X := - MDIV2 to MDIV2 do begin
      LogXY := (X * X + Y * Y - 2 * sigma * sigma) / 2 / pi / power(sigma, 6) * exp(- (X * X + Y * Y) / 2 / sigma / sigma);
      LogXY := LogXY * K;
      SXY[X + MDIV2, Y + MDIV2] := LogXY;
      Total := Total + LogXY;
      // Obhɕ\
      if (X <= 0) and (Y <= 0) then // ی̂ݕ\
        SigumaGrid.Cells[1 - X , Y + MDIV2 + 1] := FloatTostrF(LogXY, ffFixed, 10, 6);
    end;
  Label1.Caption := 'Total= ' + FloatTostr(Total);
end;

//------------------------------------------
// t@C̃I[vGrayz쐬
//------------------------------------------
procedure TForm1.OpenBtnClick(Sender: TObject);
var
  XX, YY            : Integer;                            // for loop  GG |C^[vZp
  WIC               : TWICImage;
  PD                : PByteArray;
  WD                : Integer;
begin
  OpenPictureDialog1.Filter := FileOpenFilter;
  if OpenPictureDialog1.Execute then                      // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;
      try
        WIC.LoadFromFile(OpenPictureDialog1.FileName);
        GHeight := WIC.Height;
        GWidth  := WIC.Width;
        Inputbitmap.SetSize(GWidth, GHeight);
        Inputbitmap.Canvas.Draw(0, 0, WIC);               // tH[}bgϊ 24rbgtH[}bgɂ܂
      finally
        WIC.Free;
      end;
    end
    else exit;                                            // LZI
  // Grayzɓ͉摜Zbg
  SetLength(GrayMat, GWidth, GHeight);
  for YY := 0 to GHeight - 1 do begin
    PD := Inputbitmap.ScanLine[YY];
    for XX := 0 to GWidth - 1 do begin
      WD := XX * 3;
      GrayMat[XX, YY] := PD[WD    ] * BK + PD[WD + 1] * GK + PD[WD + 2] * RK;
    end;
  end;
  // ͉摜\
  Image1.Height := GHeight;
  Image1.Width  := GWidth;
  Image1.Picture.Bitmap.SetSize(GWidth, GHeight);
  Image1.Canvas.Draw(0, 0, Inputbitmap);          // o͘gɏo
  FilterBtn.Enabled := true;
  ReDrawBtn.Enabled := False;
  crossBtn.Enabled := False;
end;

//----------------------------------
// \摜̐؂ւ
//----------------------------------
procedure TForm1.ReDrawBtnClick(Sender: TObject);
begin
  if RepF then begin
    Image1.Canvas.Draw(0, 0, Inputbitmap);        // o͘gɏo
    RepF := False;
  end
  else begin
    Image1.Canvas.Draw(0, 0, Outputbitmap);       // o͘gɏo
    RepF := True;
  end;
end;

//-----------------------------
// Вlɂ蔼aƃQC
//-----------------------------
procedure TForm1.SEditChange(Sender: TObject);
var
  Inr : double;
  ch  : integer;
begin
  val(SEdit.Text, Inr, Ch);
  if ch <> 0 then exit;
  REdit.Text := floatTostr(round((Inr + 0.1) * 4));
  KEdit.Text := floatTostr(round(power(Inr + 0.7, 4)));
end;

//----------------------------
// ݒ
//----------------------------
procedure TForm1.FormCreate(Sender: TObject);
begin
  Inputbitmap :=  Tbitmap.Create;
  Inputbitmap.PixelFormat := pf24bit;                 // 24rbgtH[}bg
  OutPutbitmap := Tbitmap.Create;
  OutPutbitmap.PixelFormat := pf24bit;                // 24rbgtH[}bg
  FilterBtn.Enabled := False;
  ReDrawBtn.Enabled := False;
  crossbtn.Enabled := False;
end;

//----------------------
// I
//----------------------
procedure TForm1.FormDestroy(Sender: TObject);
begin
  OutPutbitmap.Free;
  Inputbitmap.Free;
end;

end.
